package model;

import core.Rectangle;

/*
 * @inv getBounds().getWidth() > 0
 * @inv getBounds().getHeight() > 0
 * @inv getFillColor() != null
 * @inv getStroke() != null
 */
public interface Shape {
	public Rectangle getBounds();
	public Color getFillColor();
	public Stroke getStroke();

	public void setFillColor(Color fill);
	public void setStroke(Stroke stroke);

	// moves the shape by dx on the x-axis and by dy on the y-axis
	public void translate(int dx, int dy);
	
	// public void draw(Device d);
	
	// public void resize (double factor);
}