package test;

import model.Color;
import model.Drawing;
import model.Group;
import model.RectangleShape;
import model.Shape;
import model.Stroke;
import core.Rectangle;

public class Hanoi {

	public static Drawing createHanoiTowers() {
		final Drawing d = new Drawing(250, 200);

		Group p1 = createPeg();
		Group p2 = createPeg();
		Group p3 = createPeg();

		p2.translate(75, 0);
		p3.translate(150, 0);

		Group tower = createTower();

		d.add(p1);
		d.add(p2);
		d.add(p3);
		d.add(tower);
		return d;
	}

	private static Group createPeg() {
		Color brown = new Color(153, 051, 000, 255);
		RectangleShape base = new RectangleShape(
				new Rectangle(20, 170, 60, 20), Stroke.None);
		RectangleShape peg = new RectangleShape(new Rectangle(47, 10, 6, 160),
				Stroke.None);

		Group g = new Group(new Shape[] { base, peg });
		g.setFillColor(brown);

		return g;
	}

	private static Group createTower() {
		Shape[] s = new Shape[9];
		for (int i = 0; i < s.length; ++i) {
			s[i] = new RectangleShape(new Rectangle(30 + 2 * i, 155 - 15 * i,
					40 - 4 * i, 15), Stroke.None, new Color(0, 0, 50 + 20 * i,
					255));
		}

		Group g = new Group(s);
		g.setStroke(new Stroke(1, new Color(102, 102, 255, 130)));

		return g;
	}
}