package test;

import core.Point;
import core.Rectangle;
import model.CircleShape;
import model.Color;
import model.Drawing;
import model.RectangleShape;
import model.Shape;
import model.Stroke;

public class PartA {

	/**
	 * Tests the first part of the assignment
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		int width = 100;
		int height = 200;

		Drawing d = new Drawing(width, height);

		System.out.println("TEST: Drawing");
		testShape(d);
		if (d.getBounds().getWidth() != width)
			System.out.println("Error: incorrect width");
		if (d.getBounds().getHeight() != height)
			System.out.println("Error: incorrect height");
		if (d.getBounds().getLeft() != 0)
			System.out.println("Error: drawing cannot be moved");
		if (d.getBounds().getTop() != 0)
			System.out.println("Error: drawing cannot be moved");

		Stroke light = new Stroke(2, Color.Black);

		System.out.println("TEST: Empty rectangle");
		RectangleShape rectangle = new RectangleShape(new Rectangle(10, 10, 20,
				20), light);
		testEmptyShape(rectangle);

		System.out.println("TEST: Empty circle");
		CircleShape circle = new CircleShape(new Point(50, 50), 30, light);
		testEmptyShape(circle);

		System.out.println("TEST: Filled rectangle");
		RectangleShape filledRectangle = new RectangleShape(new Rectangle(100,
				100, 30, 30), light, Color.Blue);
		testFilledShape(filledRectangle);

		System.out.println("TEST: Filled circle");
		CircleShape filledCircle = new CircleShape(new Point(50, 50), 30,
				light, Color.White);
		testFilledShape(filledCircle);
		
		System.out.println("TEST COMPLETE !");
	}

	private static void testFilledShape(Shape shape) {
		testShape(shape);
		if (shape.getFillColor().isTransparent())
			System.out.println("Error: Filled shape is empty");
	}

	private static void testShape(Shape s) {
		if (s.getFillColor() == null)
			System.out.println("Error: invalid fill color");
		if (s.getStroke() == null)
			System.out.println("Error: invalid stroke");
	}

	private static void testEmptyShape(Shape shape) {
		testShape(shape);
		if (!shape.getFillColor().isTransparent())
			System.out.println("Error: Empty shape is filled");
	}

}
