package test;

import core.Point;
import io.JPaintLoader;
import io.JPaintSaver;
import io.Service;
import io.StandardImageSavers;
import model.CircleShape;
import model.Color;
import model.Drawing;
import model.Stroke;

public class PartE {
	public static void main(String[] args) {

		// Creates the file format management service
		Service io = new Service();

		// Registers the standard formats 
		StandardImageSavers.register(io);

		// Registers the JP format 
		JPaintSaver saver = new JPaintSaver();
		io.registerSaver("jp", saver);
		io.registerLoader("jp", new JPaintLoader());

		// Creates a drawing and saves it in all formats
		Drawing d = Hanoi.createHanoiTowers();

		io.save("hanoi", "png", d);
		io.save("hanoi", "jpg", d);
		io.save("hanoi", "bmp", d);
		io.save("hanoi", "jp", d);

		// Loads the saved drawing, adds additional circle, resizes it
		Drawing d2 = io.load("hanoi", "jp");
		d2.add(new CircleShape(new Point (20,20),10,new Stroke (2, Color.Blue)));
		d2.resize(2.5);

		// Display the two drawings
		Viewer.show(d);
		Viewer.show(d2);

	}

}
