package ui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

import core.Rectangle;

import model.Drawing;
import render.GraphicDevice;

public class ShapesPanel extends JPanel {

	private static final long serialVersionUID = -3879676408393210291L;
	private Drawing document;

	public ShapesPanel() {
	}

	public ShapesPanel(Drawing doc) {
		setDocument(doc);
	}

	public void setDocument(Drawing doc) {
		this.document = doc;
		Dimension dims = new Dimension(doc.getBounds().getWidth(), doc
				.getBounds().getHeight());
		setPreferredSize(dims);
		setOpaque(false);
		setBackground(GraphicDevice.getDeviceSpecificColor(doc.getFillColor()));
	}

	@Override
	public void paint(Graphics graphics) {
		if (document != null) {
			Graphics2D g = (Graphics2D) graphics;
			GraphicDevice device = new GraphicDevice(g);
			Rectangle bounds = document.getBounds();

			graphics.setColor(Color.BLUE);
			graphics.drawRect(0, 0, bounds.getWidth() + 1,
					bounds.getHeight() + 1);

			// g.setClip(0, 0, bounds.getWidth(), bounds.getHeight());
			graphics.clearRect(0, 0, bounds.getWidth(), bounds.getHeight());
			document.draw(device);
		}
		super.paint(graphics);
	}

}
